package main

import "./_xtest_"
import "testing"
import __os__ "os"
import __regexp__ "regexp"

var tests = []testing.InternalTest{
	{"sync_test.TestCondSignal", sync_test.TestCondSignal},
	{"sync_test.TestCondBroadcast", sync_test.TestCondBroadcast},
	{"sync_test.TestSemaphore", sync_test.TestSemaphore},
	{"sync_test.TestMutex", sync_test.TestMutex},
	{"sync_test.TestMutexPanic", sync_test.TestMutexPanic},
	{"sync_test.TestOnce", sync_test.TestOnce},
	{"sync_test.TestParallelReaders", sync_test.TestParallelReaders},
	{"sync_test.TestRWMutex", sync_test.TestRWMutex},
	{"sync_test.TestRLocker", sync_test.TestRLocker},
	{"sync_test.TestWaitGroup", sync_test.TestWaitGroup},
	{"sync_test.TestWaitGroupMisuse", sync_test.TestWaitGroupMisuse},
}

var benchmarks = []testing.InternalBenchmark{	{"sync_test.BenchmarkUncontendedSemaphore", sync_test.BenchmarkUncontendedSemaphore},
	{"sync_test.BenchmarkContendedSemaphore", sync_test.BenchmarkContendedSemaphore},
	{"sync_test.BenchmarkUncontendedMutex", sync_test.BenchmarkUncontendedMutex},
	{"sync_test.BenchmarkContendedMutex", sync_test.BenchmarkContendedMutex},
}

var matchPat string
var matchRe *__regexp__.Regexp

func matchString(pat, str string) (result bool, err __os__.Error) {
	if matchRe == nil || matchPat != pat {
		matchPat = pat
		matchRe, err = __regexp__.Compile(matchPat)
		if err != nil {
			return
		}
	}
	return matchRe.MatchString(str), nil
}

func main() {
	testing.Main(matchString, tests, benchmarks)
}
